/*
	Leaflet.contextmenu, a context menu for Leaflet.
	(c) 2015, Adam Ratcliffe, GeoSmart Maps Limited
	(c) 2021-2022, Oleg Gunyakov, Maptorium Tile Downloader
	@preserve
*/
(function(t){var e;if(typeof define==="function"&&define.amd){define(["leaflet"],t)}else if(typeof module==="object"&&typeof module.exports==="object"){e=require("leaflet");module.exports=t(e)}else{if(typeof window.L==="undefined"){throw new Error("Leaflet must be loaded first")}t(window.L)}})(function(d){d.Map.mergeOptions({contextmenuItems:[]});d.Map.ContextMenu=d.Handler.extend({_touchstart:d.Browser.msPointer?"MSPointerDown":d.Browser.pointer?"pointerdown":"touchstart",statics:{BASE_CLS:"dropdown-menu"},initialize:function(t){d.Handler.prototype.initialize.call(this,t);this._items=[];this._visible=false;var e=this._container=d.DomUtil.create("div",d.Map.ContextMenu.BASE_CLS,t._container);e.style.zIndex=1e4;e.style.position="absolute";if(t.options.contextmenuWidth){e.style.width=t.options.contextmenuWidth+"px"}this._createItems();d.DomEvent.on(e,"click",d.DomEvent.stop).on(e,"mousedown",d.DomEvent.stop).on(e,"dblclick",d.DomEvent.stop).on(e,"contextmenu",d.DomEvent.stop)},addHooks:function(){var t=this._map.getContainer();d.DomEvent.on(t,"mouseleave",this._hide,this).on(document,"keydown",this._onKeyDown,this);if(d.Browser.touch){d.DomEvent.on(document,this._touchstart,this._hide,this)}this._map.on({contextmenu:this._show,mousedown:this._hide,zoomstart:this._hide},this)},removeHooks:function(){var t=this._map.getContainer();d.DomEvent.off(t,"mouseleave",this._hide,this).off(document,"keydown",this._onKeyDown,this);if(d.Browser.touch){d.DomEvent.off(document,this._touchstart,this._hide,this)}this._map.off({contextmenu:this._show,mousedown:this._hide,zoomstart:this._hide},this)},showAt:function(t,e){if(t instanceof d.LatLng){t=this._map.latLngToContainerPoint(t)}this._showAtPoint(t,e)},hide:function(){this._hide()},addItem:function(t){return this.insertItem(t)},insertItem:function(t,e){e=e!==undefined?e:this._items.length;var n=this._createItem(this._container,t,e);this._items.push(n);this._sizeChanged=true;this._map.fire("contextmenu.additem",{contextmenu:this,el:n.el,index:e});return n.el},removeItem:function(t){var e=this._container;if(!isNaN(t)){t=e.children[t]}if(t){this._removeItem(d.Util.stamp(t));this._sizeChanged=true;this._map.fire("contextmenu.removeitem",{contextmenu:this,el:t});return t}return null},removeAllItems:function(){var t=this._container.children,e;while(t.length){e=t[0];this._removeItem(d.Util.stamp(e))}return t},hideAllItems:function(){var t,e,n;for(e=0,n=this._items.length;e<n;e++){t=this._items[e];t.el.style.display="none"}},showAllItems:function(){var t,e,n;for(e=0,n=this._items.length;e<n;e++){t=this._items[e];t.el.style.display=""}},setDisabled:function(t,e){var n=this._container,i="dropdown-item";if(!isNaN(t)){t=n.children[t]}if(t&&d.DomUtil.hasClass(t,i)){if(e){d.DomUtil.addClass(t,"disabled");this._map.fire("contextmenu.disableitem",{contextmenu:this,el:t})}else{d.DomUtil.removeClass(t,"disabled");this._map.fire("contextmenu.enableitem",{contextmenu:this,el:t})}}},isVisible:function(){return this._visible},_createItems:function(){var t=this._map.options.contextmenuItems,e,n,i;for(n=0,i=t.length;n<i;n++){this._items.push(this._createItem(this._container,t[n]))}},_createItem:function(t,e,n){if(e.separator||e==="-"){return this._createSeparator(t,n)}var i="dropdown-item",o=e.disabled?i+" disabled":i,o=e.class?i+" "+e.class:i,s=this._insertElementAt("button",o,t,n),r=this._createEventHandler(s,e.callback,e.context,e.hideOnSelect),h=this._getIcon(e),a=this._getIconCls(e),m="";if(h){m='<img src="'+h+'"/>'}else if(a){m='<i class="'+a+'"></i>'}s.innerHTML=m+"<span>&nbsp;"+e.text+"</span>";s.href="#";d.DomEvent.on(s,"mouseover",this._onItemMouseOver,this).on(s,"mouseout",this._onItemMouseOut,this).on(s,"mousedown",d.DomEvent.stopPropagation).on(s,"click",r);if(d.Browser.touch){d.DomEvent.on(s,this._touchstart,d.DomEvent.stopPropagation)}if(!d.Browser.pointer){d.DomEvent.on(s,"click",this._onItemMouseOut,this)}return{id:d.Util.stamp(s),el:s,callback:r}},_removeItem:function(t){var e,n,i,o,s;for(i=0,o=this._items.length;i<o;i++){e=this._items[i];if(e.id===t){n=e.el;s=e.callback;if(s){d.DomEvent.off(n,"mouseover",this._onItemMouseOver,this).off(n,"mouseover",this._onItemMouseOut,this).off(n,"mousedown",d.DomEvent.stopPropagation).off(n,"click",s);if(d.Browser.touch){d.DomEvent.off(n,this._touchstart,d.DomEvent.stopPropagation)}if(!d.Browser.pointer){d.DomEvent.on(n,"click",this._onItemMouseOut,this)}}this._container.removeChild(n);this._items.splice(i,1);return e}}return null},_createSeparator:function(t,e){var n=this._insertElementAt("div","dropdown-divider",t,e);return{id:d.Util.stamp(n),el:n}},_createEventHandler:function(h,a,m,u){var l=this,t=this._map,c="disabled",u=u!==undefined?u:true;return function(t){if(d.DomUtil.hasClass(h,c)){return}var e=l._map,n=l._showLocation.containerPoint,i=e.containerPointToLayerPoint(n),o=e.layerPointToLatLng(i),s=l._showLocation.relatedTarget,r={containerPoint:n,layerPoint:i,latlng:o,relatedTarget:s};if(u){l._hide()}if(a){a.call(m||e,r)}l._map.fire("contextmenu.select",{contextmenu:l,el:h})}},_insertElementAt:function(t,e,n,i){var o,s=document.createElement(t);s.className=e;if(i!==undefined){o=n.children[i]}if(o){n.insertBefore(s,o)}else{n.appendChild(s)}return s},_show:function(t){this._showAtPoint(t.containerPoint,t)},_showAtPoint:function(t,e){if(this._items.length){var n=this._map,i=d.extend(e||{},{contextmenu:this});this._showLocation={containerPoint:t};if(e&&e.relatedTarget){this._showLocation.relatedTarget=e.relatedTarget}this._setPosition(t);if(!this._visible){this._container.style.display="block";this._visible=true}this._map.fire("contextmenu.show",i)}},_hide:function(){if(this._visible){this._visible=false;this._container.style.display="none";this._map.fire("contextmenu.hide",{contextmenu:this})}},_getIcon:function(t){return d.Browser.retina&&t.retinaIcon||t.icon},_getIconCls:function(t){return d.Browser.retina&&t.retinaIconCls||t.iconCls},_setPosition:function(t){var e=this._map.getSize(),n=this._container,i=this._getElementSize(n),o;if(this._map.options.contextmenuAnchor){o=d.point(this._map.options.contextmenuAnchor);t=t.add(o)}n._leaflet_pos=t;if(t.x+i.x>e.x){n.style.left="auto";n.style.right=Math.min(Math.max(e.x-t.x,0),e.x-i.x-1)+"px"}else{n.style.left=Math.max(t.x,0)+"px";n.style.right="auto"}if(t.y+i.y>e.y){n.style.top="auto";n.style.bottom=Math.min(Math.max(e.y-t.y,0),e.y-i.y-1)+"px"}else{n.style.top=Math.max(t.y,0)+"px";n.style.bottom="auto"}},_getElementSize:function(t){var e=this._size,n=t.style.display;if(!e||this._sizeChanged){e={};t.style.left="-999999px";t.style.right="auto";t.style.display="block";e.x=t.offsetWidth;e.y=t.offsetHeight;t.style.left="auto";t.style.display=n;this._sizeChanged=false}return e},_onKeyDown:function(t){var e=t.keyCode;if(e===27){this._hide()}},_onItemMouseOver:function(t){d.DomUtil.addClass(t.target||t.srcElement,"over")},_onItemMouseOut:function(t){d.DomUtil.removeClass(t.target||t.srcElement,"over")}});d.Map.addInitHook("addHandler","contextmenu",d.Map.ContextMenu);d.Mixin.ContextMenu={bindContextMenu:function(t){d.setOptions(this,t);this._initContextMenu();return this},unbindContextMenu:function(){this.off("contextmenu",this._showContextMenu,this);return this},addContextMenuItem:function(t){this.options.contextmenuItems.push(t)},removeContextMenuItemWithIndex:function(t){var e=[];for(var n=0;n<this.options.contextmenuItems.length;n++){if(this.options.contextmenuItems[n].index==t){e.push(n)}}var i=e.pop();while(i!==undefined){this.options.contextmenuItems.splice(i,1);i=e.pop()}},replaceContextMenuItem:function(t){this.removeContextMenuItemWithIndex(t.index);this.addContextMenuItem(t)},_initContextMenu:function(){this._items=[];this.on("contextmenu",this._showContextMenu,this)},_showContextMenu:function(t){var e,n,i,o,s;if(this._map.contextmenu){n=d.extend({relatedTarget:this},t);i=this._map.mouseEventToContainerPoint(t.originalEvent);if(!this.options.contextmenuInheritItems){this._map.contextmenu.hideAllItems()}for(o=0,s=this.options.contextmenuItems.length;o<s;o++){e=this.options.contextmenuItems[o];this._items.push(this._map.contextmenu.insertItem(e,e.index))}this._map.once("contextmenu.hide",this._hideContextMenu,this);this._map.contextmenu.showAt(i,n)}},_hideContextMenu:function(){var t,e;for(t=0,e=this._items.length;t<e;t++){this._map.contextmenu.removeItem(this._items[t])}this._items.length=0;if(!this.options.contextmenuInheritItems){this._map.contextmenu.showAllItems()}}};var t=[d.Marker,d.Path],e={contextmenu:false,contextmenuItems:[],contextmenuInheritItems:true},n,i,o;for(i=0,o=t.length;i<o;i++){n=t[i];if(!n.prototype.options){n.prototype.options=e}else{n.mergeOptions(e)}n.addInitHook(function(){if(this.options.contextmenu){this._initContextMenu()}});n.include(d.Mixin.ContextMenu)}return d.Map.ContextMenu});